
#ifndef __MYRADIO_GPIO_H_
#define __MYRADIO_GPIO_H_

#include <stdint.h>

#include "stm32f10x.h"
#include "stm32f10x_gpio.h"
#include "stm32f10x_spi.h"
#include "board.h"

#define SPI_HARD
typedef void (*RADIO_GPIO_CALLBACK)(uint8_t index);

void BOARD_SPI_NSS_H(void);
void BOARD_SPI_NSS_L(void);

void BOARD_GPIOA_H(void);
void BOARD_GPIOA_L(void);
void BOARD_GPIOB_H(void);
void BOARD_GPIOB_L(void);
void BOARD_GPIOC_H(void);
void BOARD_GPIOC_L(void);
void BOARD_GPIOD_H(void);
void BOARD_GPIOD_L(void);
void BOARD_GPIOE_H(void);
void BOARD_GPIOE_L(void);
void BOARD_GPIOF_H(void);
void BOARD_GPIOF_L(void);
void BOARD_GPIOG_H(void);
void BOARD_GPIOG_L(void);
void BOARD_GPIOH_H(void);
void BOARD_GPIOH_L(void);
uint8_t READ_BOARD_GPIOA(void);
uint8_t READ_BOARD_GPIOB(void);
uint8_t READ_BOARD_GPIOC(void);
uint8_t READ_BOARD_GPIOD(void);
uint8_t READ_BOARD_GPIOE(void);
uint8_t READ_BOARD_GPIOF(void);
uint8_t READ_BOARD_GPIOG(void);
uint8_t READ_BOARD_GPIOH(void);

#define RF_EXT_PA_RE_H() BOARD_GPIOE_H()
#define RF_EXT_PA_RE_L() BOARD_GPIOE_L()
#define RF_EXT_PA_TE_H() BOARD_GPIOF_H()
#define RF_EXT_PA_TE_L() BOARD_GPIOF_L()

#define RF_EXT_PA_TO_TX() RF_EXT_PA_TE_H();RF_EXT_PA_RE_L()
#define RF_EXT_PA_TO_RX() RF_EXT_PA_TE_L();RF_EXT_PA_RE_H()
#define RF_EXT_PA_TO_IDLE() RF_EXT_PA_TE_L();RF_EXT_PA_RE_L()

void myRadio_gpio_init(RADIO_GPIO_CALLBACK cb);
uint8_t myRadioSpi_rwByte(uint8_t byteToWrite);
void myRadioSpi_wBuffer(uint8_t* pData, uint8_t byteCount);
void myRadioSpi_rBuffer(uint8_t* pData, uint8_t byteCount);

#define myRadioSpi_rwByte(p) SpiReadWrite(p)
#define myRadioSpi_wBuffer(p1, p2) SpiWriteData(p2, p1)
#define myRadioSpi_rBuffer(p1, p2) SpiReadData(p2, p1)
#endif
